﻿(function()
{	

	Components.utils.import("resource://gre/modules/ctypes.jsm");
	Components.utils.import("resource://gre/modules/DownloadLastDir.jsm");

	var file = getFile("chrome://mailattention/content/avl_detect.so")
	var lib = ctypes.open(file.path);
	
	var init = lib.declare("init", ctypes.default_abi, ctypes.int32_t);
//	var url_scan = lib.declare("url_scan", ctypes.default_abi, ctypes.int32_t, ctypes.char.ptr);
	var download_scan = lib.declare("download_scan", ctypes.default_abi, ctypes.int32_t, ctypes.char.ptr);
	var exit = lib.declare("exit_detect", ctypes.default_abi, ctypes.int32_t);
	
	init();


	function getFile(chromeURL) 
	{
	// convert the chrome URL into a file URL
		var cr = Components.classes['@mozilla.org/chrome/chrome-registry;1']
			.getService(Components.interfaces.nsIChromeRegistry);
		
		var io = Components.classes['@mozilla.org/network/io-service;1']
			.getService(Components.interfaces.nsIIOService);
		
		var uri = io.newURI(decodeURI(chromeURL), 'UTF-8', null);
		
		var fileURL = cr.convertChromeURL(uri);
	// get the nsILocalFile for the file
		return  fileURL.QueryInterface(Components.interfaces.nsIFileURL).file;
	}

	var downloadManager = Components.classes["@mozilla.org/download-manager;1"].getService(Components.interfaces.nsIDownloadManager);
	
//获取附件保存目录
	downloadManager.addListener(
	{
		onProgressChange : function(prog, req, prog, progMax, tProg, tProgMax, dl) {},
		onDownloadStateChange : function(state, dl)
		{	
			if(state == 0)
			{	
				var download_dir = dl.targetFile.path;
				download_scan(download_dir);
			}
		},
		onStateChange : function(prog, req, flags, status, dl) {}
	});

	window.onunload = function() { lib.close();exit(); }
})();
/*
	window.addEventListener('load', function()
	{	
		var newMailListener =
		{
			msgAdded: function(msgHdr)
			{
				if(!msgHdr.isRead)
				{
				//alert(msgHdr.folder.filePath.persistentDescriptor);
					if(msgHdr.flags & 0x10000000)  
					{

					}
				}
			}
		}
		var notificationService = Components.classes["@mozilla.org/messenger/msgnotificationservice;1"]
			.getService(Components.interfaces.nsIMsgFolderNotificationService);
		notificationService.addListener(newMailListener, notificationService.msgAdded);		
		},false);


*/

/*
function readAttachment(attachment)
{
	Components.utils.import("resource://gre/modules/Services.jsm");  
	Components.utils.import("resource://gre/modules/NetUtil.jsm");  
  
	let url = Services.io.newURI(attachment.url, null, null);  
	let channel = Services.io.newChannelFromURI(url);  
	let chunks = [];  
  

	let unicodeConverter = Cc["@mozilla.org/intl/scriptableunicodeconverter"]  
	                       .createInstance(Ci.nsIScriptableUnicodeConverter);  
	unicodeConverter.charset = "UTF-8";  
	let listener = {  
	  onStartRequest: function ( aRequest,  aContext) { },  
	  
	  onStopRequest: function ( aRequest, aContext, aStatusCode) {  
	    let data = chunks.join("");  
	  },  
  
	  onDataAvailable: function (aRequest,  aContext, aStream,  aOffset,  aCount) 
	  {  

	    let data = NetUtil.readInputStreamToString(aStream, aCount);  
	  
 
	    let array = [];  
	    for (let i = 0; i < data.length; ++i)  
	      array[i] = data.charCodeAt(i);  
	    
	    chunks.push(unicodeConverter.convertFromByteArray(array, array.length)); 
  	},  
  
  	QueryInterface: XPCOMUtils.generateQI([Ci.nsISupports, Ci.nsIStreamListener, Ci.nsIRequestObserver])  
	};  
	channel.asyncOpen(listener, null);  
}
*/
/******************************
 * monitor download event      *
 * get download directory      *
 ******************************/ 





/*
function readOffline(mail) 
{
  var key = mail.messageKey;
  var offset = new Object();
  var messageSize = new Object();
  var is;
  var bodyAndHdr;

  try{ is = mail.folder.getOfflineFileStream(key,offset,messageSize); }
  catch(e){ alert("message: "+e.message); }
  try{
      var sis = factory.createInstance(
          Components.interfaces.nsIScriptableInputStream
      );
			sis.init(is);
			bodyAndHdr = sis.read(mail.messageSize);
			sis.close();
			is.close();       
		} catch(e){ alert("message: "+e.message); }
  alert(bodyAndHdr);
}


function readOnline( mail) {
  var key = mail.messageKey;
  var uri = mail.folder.generateMessageURI(key);
  var messenger = Components.classes['@mozilla.org/messenger;1']
                  .createInstance();
  messenger = messenger.QueryInterface(
                  Components.interfaces.nsIMessenger
              );
  var messageService = messenger.messageServiceFromURI(uri);
	var aurl = new Object();
  messageService.CopyMessage(uri,
      myStreamListener, false, null, msgWindow, aurl);
}

var myStreamListener = {
   onDataAvailable: 
      function(request, context, inputStream, offset, count){
          try {
              var sis= Components.
                       classes["@mozilla.org/scriptableinputstream;1"]
                       .createInstance(
                          Components.interfaces.nsIScriptableInputStream
                       );
              sis.init(inputStream);
              bodyAndHdr += sis.read(count);
          }
          catch(ex) { alert("exception caught: "+ex.message+"/n"); }
   },
   onStartRequest: function(request, context) { },
   onStopRequest: function(aRequest, aContext, aStatusCode) {
      alert(bodyAndHdr);
   }
};

*/
