
(function() 
{

	Components.utils.import("resource://gre/modules/ctypes.jsm");
	Components.utils.import("resource://gre/modules/DownloadLastDir.jsm");

	var file = getFile("chrome://urlblocker/content/avl_detect.so")
	var lib = ctypes.open(file.path);
	
	var init = lib.declare("init", ctypes.default_abi, ctypes.int32_t);
	var url_scan = lib.declare("url_scan", ctypes.default_abi, ctypes.int32_t, ctypes.char.ptr);
	var download_scan = lib.declare("download_scan", ctypes.default_abi, ctypes.int32_t, ctypes.char.ptr);
	var exit = lib.declare("exit_detect", ctypes.default_abi, ctypes.int32_t);
	
	init();
	
	var Sys = {};
	var ua = navigator.userAgent.toLowerCase();

	if (document.getBoxObjectFor)
		Sys.firefox = ua.match(/firefox\/([\d.]+)/)[1]

	var num = version_compare();
	

/******************************
 * set the homepage * 
 ******************************/

    function load()
    {


        Components.utils.import("resource://gre/modules/ctypes.jsm");
        Components.utils.import("resource://gre/modules/DownloadLastDir.jsm");
        
        var file = getFile("chrome://urlblocker/content/homepage_lock.so")
        var lib  = ctypes.open(file.path);

        var init       = lib.declare("init", ctypes.default_abi, ctypes.int32_t);
        var url_config = lib.declare("get_url_from_config", ctypes.default_abi, ctypes.int32_t, ctypes.char.ptr);
        var uninit     = lib.declare("uninit", ctypes.default_abi, ctypes.int32_t);
		
	    init();
        
        let outputType = ctypes.char.array(2048);
        let output     = outputType();
        
        var url = url_config(output);
        
        /*if(url == 0)
        {
            alert("成功");
        }*/
            
        if(url == 0)
        {
            var m_string = output.readString();
            //alert(m_string);
        
            //gBrowser.loadURI(m_string);
                
			var prefBranch = Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService).getBranch("browser.startup.");
            prefBranch.setCharPref('homepage', m_string);
        }

        uninit(); 
	    lib.close();
		var prefService = Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService);
        prefService.savePrefFile(null);
    }


	function getFile(chromeURL) 
	{
	// convert the chrome URL into a file URL
		var cr = Components.classes['@mozilla.org/chrome/chrome-registry;1']
			.getService(Components.interfaces.nsIChromeRegistry);
		
		var io = Components.classes['@mozilla.org/network/io-service;1']
			.getService(Components.interfaces.nsIIOService);
		
		var uri = io.newURI(decodeURI(chromeURL), 'UTF-8', null);
		
		var fileURL = cr.convertChromeURL(uri);
	// get the nsILocalFile for the file
		return  fileURL.QueryInterface(Components.interfaces.nsIFileURL).file;
	}


	function version_compare()
	{
		var arr = Sys.firefox.split(".");
		
		if( arr[0] <= 16 )
			return 0;
		else if( arr[0] <= 26 )
			return 1;
		else
			return 2;
	}


	window.onunload = function() { lib.close();exit(); }
    window.addEventListener("load", load, false);

/******************************
 * monitor open tab page event *
 * get will browse url         * 
 ******************************/
	document.addEventListener("DOMWindowCreated", 
		function check_url(event)
		{

			document.removeEventListener("DOMWindowCreated", check_url, false);
			var appcontent = document.getElementById("appcontent");
			if(appcontent)
			{

				appcontent.addEventListener("DOMWindowCreated", pluginDetect, true);
			}
			
		}
	, false);



 /******************************
 * get url of open tab         *
 * detect url by antiy engine  *  
 * block black url             *
 ******************************/ 
	function pluginDetect()
	{
		var url = window.content.document.URL;
		
		var ret = url.indexOf("chrome://urlblocker/content/err.html/?url=");
	
		if(ret == -1)
		{
			var url_param = "chrome://urlblocker/content/err.html/?url=" + url;
			var flags = url_scan(url);
			if(flags == 3)
			{
	    		gBrowser.loadURI(url_param);
			}


		}
		else
		{
			console.log("the begin string is chrome");
		}

	}

/******************************
 * monitor download event      *
 * get download directory      *
 ******************************/ 
	var downloadManager = Components.classes["@mozilla.org/download-manager;1"].getService(Components.interfaces.nsIDownloadManager);
	
	downloadManager.addListener(
	{
		onProgressChange : function(prog, req, prog, progMax, tProg, tProgMax, dl) {},
		onDownloadStateChange : function(state, dl)
		{	
                        //alert(state);
			if(state == 0)
			{	
				var download_dir = dl.targetFile.path;
                        	//alert(download_dir);
				download_scan(download_dir);
			}
		},
		onStateChange : function(prog, req, flags, status, dl) {}
	});



})();



