#! /bin/bash


#开机启动项注册
function regist_auto_run
{
	path=`which systemctl`
	if [ "$?" != "0" ];then
	chk_path=`which chkconfig`
	if [ "$?" != "0" ];then
		runlev=`runlevel  | cut -d' ' -f 2`
			ln -sf /opt/LinuxKPC/kismain /etc/rc${runlev}.d/S99kismain
			chmod 775 /etc/rc${runlev}.d/S99kismain
	else
			ln -sf /opt/LinuxKPC/kismain /etc/init.d/kismain
			chmod 775 /etc/init.d/kismain
			chkconfig kismain on
	fi
	else
			systemctl disable kismain.service
			rm -f /lib/systemd/system/kismain.service
			cp /opt/LinuxKPC/kismain.service /lib/systemd/system/
			chmod 755 /lib/systemd/system/kismain.service
			systemctl enable kismain.service
	fi
}


function unregist_auto_run
{
	path=`which systemctl`
	if [ "$?" != "0" ];then
	chk_path=`which chkconfig`
	if [ "$?" != "0" ];then
		runlev=`runlevel  | cut -d' ' -f 2`
			ln -sf /opt/LinuxKPC/kismainunreg /etc/rc${runlev}.d/S99kismain
			chmod 775 /etc/rc${runlev}.d/S99kismain
	else
        ln -sf /opt/LinuxKPC/kismainunreg /etc/init.d/kismain
        chmod 775 /etc/init.d/kismain
        chkconfig kismain on
	fi
	else
        systemctl disable kismain.service
        rm -f /lib/systemd/system/kismain.service
        cp /opt/LinuxKPC/kismain.serviceunreg /lib/systemd/system/kismain.service
        chmod 755 /lib/systemd/system/kismain.service
        systemctl enable kismain.service
	fi
}

#语系
function get_current_locale()
{
	var=`locale | grep LC_CTYPE | cut -d '"' -f 2 | cut -d '.' -f 1`

	echo ${var}
}
current_locale=`get_current_locale`


function install_system_kistray()
{
        kistray=$1
        echo '[Desktop Entry]'                          >> /etc/xdg/autostart/$kistray
        echo 'Type=Application'                         >> /etc/xdg/autostart/$kistray
        echo 'Name=kismain'                        	>> /etc/xdg/autostart/$kistray
	local title="安天智甲终端防御系统"
	if [ "${current_locale}" = "en_US" ]; then
		title="IEP Client"
	fi
        echo "Name[en_US]=${title}"       		>> /etc/xdg/autostart/$kistray
        echo 'Comment='                   		>> /etc/xdg/autostart/$kistray
        echo 'Exec=/opt/LinuxKPC/start_client.sh'       >> /etc/xdg/autostart/$kistray
        echo 'X-GNOME-Autostart-Notify=false'           >> /etc/xdg/autostart/$kistray
        echo 'X-GNOME-Autostart-enabled=true'           >> /etc/xdg/autostart/$kistray
        echo 'X-GNOME-AutoRestart=true'                 >> /etc/xdg/autostart/$kistray
        chmod 755 /etc/xdg/autostart/$kistray
}

if [ "$1" == "-regist" ];then
	regist_auto_run
	install_system_kistray 'kismain.desktop'
elif [ "$1" == "-unregist" ];then
	unregist_auto_run
	rm -f /etc/xdg/autostart/kismain.desktop
else
	echo ""
fi
