#!/usr/bin/env bash

#delete malicious service
malicious_service="/etc/systemd/system/cloud_agent.service"
if [ -f $malicious_service ]; then
	grep "/tmp/seasame" $malicious_service > /dev/null
	if [ $? -eq 0 ]; then
		rm $malicious_service
	fi
fi

#delete malicious crontab
crontab -l | grep -v '/tmp/seasame' | crontab -


malicious_hash_arr=("cd4bf850a354a80eb860586d253a4385" "d71eb083e7943f0641982797c09f3e73" "3e86ec46f977a954f304d64ffeadf062")
#get new_bash filename and clear malicious files
bashmd5=$(md5sum `command -v bash` | cut -d ' ' -f1)
new_bash=""

findfiles=$(find /tmp -xdev -type f)
for file in ${findfiles[@]};do
	filemd5=$(md5sum "$file" | cut -d ' ' -f1)
	for malhash in ${malicious_hash_arr[@]};do
		if [ $filemd5 = $malhash ];then
			rm $file
		fi
	done
	if [ $filemd5 = $bashmd5 ];then
		new_bash=`basename $file`
	fi
done

#kill malicious processes
if [ -n $new_bash ];then
	findpids=$(ps -el | grep $new_bash | grep -v grep | awk '{print $4}')
	for pid in ${findpids[@]};do
		kill -9 $pid
	done
fi

#kill miner processe
findpids=$(ps aux | grep '/boot/vmlinuz' | awk '{if($3>30.0) print $2}')
for pid in ${findpids[@]};do
	kill -9 $pid
done
exit 0
